unit RB_UNIT;          {!!!  16-09-2005  !!!}

{$A+,B-,D+,E-,F+,G+,I-,L+,N-,O+,P-,Q-,R-,S-,T-,V-,X+,Y+}

interface


uses DOS;


const
  Exp2 : array[0..16] of longint =
   (1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384,
    32768, 65536);
  Power2 : array[0..7] of byte = (1, 2, 4, 8, 16, 32, 64, 128);
  chSep : char = '\';
  MaxTask = 15;


type
  B8192 = array[0..8191] of byte;

  Str2 = string[2];
  Str16 = string[16];
  Str32 = string[32];
  Str80 = string[80];

  t_ask=record
    _le : array[0..MaxTask] of byte;
    _me, _qu, _tm : array[0..MaxTask] of Str80;
    _bLastKey : byte;
   end;

  t_graph=record
    _x1,_y1,_x2,_y2 : integer; { coordinaten }
    _pi,                { 0=geen PUSHIMAGE 1=memory 2=schijf}
    _so   : byte;       { soort raam: 0=raam, 1=raam2, 2=mraam, 3=mraam2}
                        { 3-7:  idem met smalle randen }
                        { 8-15: idem met schaduwrand }
    _oc   : char;       { oplichtende char }
    _kt   : Str80;      { koptext }
   end;

  t_instr =record
    klActTxt,
    klActBck,
    klNotActTxt,
    klNotActBck,
    bLastKey,
    bLength : byte;
    stLine,
    stWhat,
    stValidU : str80;
   end;

  t_item=record
    _itkop, _ittem, _itval,
    _Filename              : Str80;
    _itso                  : integer;
   end;

  t_menu=record
    _hl,              { line to be highlighted }
    _Filename : Str80;
    _ar : longint;    { # regels }
    _mk : byte;       { menukeus }
    _mu : boolean;    {    --      muis }
    _mg : boolean;    { muis grensgebonden}
    _li : string[50]; { oplichtende letters }
    _me : array[0..49] of str80;
   end;

  t_one=record
    _kop, _qu : str80;
    _sl       : integer;
    _bLastKey : byte;
   end;


var
  tImage : array[1..20] of
   record
    Bezet  : byte;
    Buffer : pointer;
   end;

  klMenuBckgnd,
  klMenuTxt,

  klMessage,               {Text message-line}           {8}
  klMessageBck,            {Background message-line}     {9}

  klPanBorder,             {Border of panel}             {1}
  klPanBordBck,            {Background border of panel}  {0}
  klPanBckgnd,                                           {3}
  klPanTxt,                                              {4}
  klPanHead,
  klPanHeadBck,                                          {2}
  klPanHighBck,            {Highlighted bar}             {5}
  klPanHighTxt,            {Text in bar}                 {6}
  klPanChar,               {Highlighted character}       {7}

  klQueBckgnd,
  klQueHighBck,
  klQueHighTxt,
  klQueTxt,

  klSMenuBckgnd,
  klSMenuTxt,
  klSMenuChoice,
  klSMenuHighBck,
  klSMenuHighTxt,
  klSMenuBorder,

  klErrBckgnd,
  klErrHeadTxt,
  klErrTxt,
  klErrHighBck,
  klErrHighTxt    : byte;

  TimeSep, DateSep, ThousandSep : char;

  TempDir : Str80;

  MaxX, MaxY, DateFormat : word;


function  AddThousandSep(l : longint) : string;
function  A64_ASM(Re1 : string) : string;
function  AS2Spac(Re1 : string) : string;
function  BIOSCOM(COMNo : Word) : Word;
function  BIOSLPT(LPTNo : Word) : Word;
function  Blank(N:Integer):String;
function  Byte2Bit(pby : byte):string;
function  CenterTxt(pst : string; bs, be : byte) : string;
function  CutExtension(pst : string) : string;
function  Dec2Bit(plo : longint; pby2 : byte) : string;
function  Dec2Hex(plo:longint; pby2:byte) : Str80;
function  Dirname2ext(filenaam:string) : string;
function  Dirname2name(filenaam:string) : string;
function  DriveValid(Drive: Char): Boolean;
function  DT2Date(dt : DateTime) : string;
function  DT2Time(dt : DateTime) : string;
function  exists(filenaam:string):boolean;
function  FastDisk : char;
function  File2drive(filenaam:string) : char;
function  File2ext(filenaam:string) : string;
function  File2Fname(filenaam:string) : string;
function  File2name(filenaam:string) : string;
function  File2path(filenaam:string) : string;
function  GetCursorMode : word;
function  GetDateTime : longint;
function  GetHexDateTime : Str16;
function  GetScreenHeight : byte;
function  Int2Str(I : Longint) : String;
function  IsVGA : boolean;
function  LeadingZero(w : Word) : String;
function  LeadingZeros(w, t : Word) : String;
function  lengte(Regel : string) : word;
function  lower(s:string) : string;
function  Lshort(pst:string):string;
function  ml(pst:string; m:byte; pbo:boolean):string;
function  NoSpace(pst : string) : string;
function  ReadKeyboard : char;
function  RightPos(C: Char; const S: string): Byte;
function  RightPosSt(C: string; const S: string): Byte;
function  Rshort(pst:string):string;
function  Short(pst:string):string;
function  stDate : string;
function  stTime : string;
function  stTime2 : string;
function  tChooseItem(var tit : t_item) : Str80;
function  tListMenu(var lm : t_menu; var pgr : t_graph) : Str80;
function  upper(s:string) : string;
function  RB_Zin(b : byte) : Str80;
procedure  Beeep;
procedure  ClrWindow;
procedure  CursorOff;
procedure  CursorOn;
procedure  DeleteS(var pst : string; i, c : integer);
procedure  GetSDate(var sD, sM, sY, sW : str2);
procedure  GetSTime(var sH, sM, sS, sW : str2);
procedure  InitCountry;
procedure  MWrite(pst : str80; width : byte);
procedure  MWriteln(pst : str80; width : byte);
procedure  Place(x,y,c:byte);
procedure  Place2(x,y,c:byte);
procedure  PWait(w : word);
procedure  RK;
procedure  SetCursorMode(Mode : word);
procedure  SetWindowDefaults(WriteFile:boolean; Mode:word);
procedure  Sort_ar(Fname : str80);
procedure  tAsk(var ramm : t_graph; show : t_menu; var pask : t_ask);
procedure  Task_one(var po : t_one);
procedure  Tgwrite(var p_gwrite : t_graph);
procedure  TInstr(var Rec : t_instr);
procedure  tMessage(pst : string);
procedure  TPopImage(var p_image : byte);
procedure  TPushImage(var p_image : byte);
procedure  TRaam(var tg : t_graph);
procedure  TShowBaseline(pst : string);
procedure  TShowMenu(var sm : t_menu; pgr : t_graph);
procedure  TSRaam(var ramm : t_graph);
procedure  Wait;
procedure  WaitKey;


{============================================================================}

implementation


uses CRT, Mouse;


{============================================================================}


{$F+}


function A64_ASM(Re1 : string) : string;
var
  by : byte;
  Re2 : str80;
label L1;

 function lengte(Regel : str80) : byte;
 var
   by : byte;
   pst : str80;
 begin
   pst := '';
   by := 1;

   while (by <= length(Regel)) do
    begin
     if (Regel[by] <> #9) then pst := pst + Regel[by] else
      begin
       pst := pst + ' ';
       while (length(pst) mod 8 > 0) do pst := pst + ' ';
      end;

     inc(by);
    end;

   lengte := length(pst);
 end;

begin
  Re2 := '';

  if (Re1 = '') then A64_ASM := ''
   else

  if (Re1[1] = ';') then A64_ASM := Re1 else
   begin
    if (Re1[1] in [' ', #9]) then
     begin
      Re1 := short(Re1);
      if (Re1 = '') then goto L1;

      Re2 := #9#9;
     end
      else

    if (Re1[1] <> '.') then
     begin
      by := 0;
      while (not (Re1[by+1] in [' ', #9]) and (by < length(Re1))) do inc(by);
      Re2 := copy(Re1, 1, by);
      DeleteS(Re1, 1, by);
      if (Re1 = '') then goto L1;

      while (lengte(Re2) < 16) do Re2 := Re2 + #9;
     end;

    if (Re1[1] = '.') then
     begin
      if (   (upper(copy(Re1, 2, 2)) = 'EQ')
          or (upper(copy(Re1, 2, 2)) = 'AL')) then
       begin
        by := 0;
        while ((Re1[by+1] <> '=') and (by < length(Re1))) do inc(by);
        Re2 := Re2 + copy(Re1, 1, by);
        if (lengte(Re2) < 16) then Re2 := Re2 + #9;
        Re2 := Re2 + '= ';
        DeleteS(Re1, 1, by+1);
        if (Re1 = '') then goto L1;
       end;

      by := 0;
      while ((Re1[by+1] <> ';') and (by < length(Re1))) do inc(by);
      Re2 := Re2 + copy(Re1, 1, by);
      DeleteS(Re1, 1, by);
     end
      else
     begin
      by := 0;
      while (not (Re1[by+1] in [' ', #9]) and (by < length(Re1))) do inc(by);
      Re2 := Re2 + copy(Re1, 1, by);
      DeleteS(Re1, 1, by);
      if (Re1 = '') then goto L1;

      Re2 := Re2 + #9;
     end;

    if (Re1[1] <> ';') then
     begin
      by := 0;
      while (not (Re1[by+1] in [' ', #9]) and (by < length(Re1))) do inc(by);
      Re2 := Re2 + copy(Re1, 1, by);
      DeleteS(Re1, 1, by);
      if (Re1 = '') then goto L1;

      Re2 := Re2 + #9;
     end;

    while (lengte(Re2) < 40) do Re2 := Re2 + #9;
    Re2 := Re2 + Re1;

L1:
    A64_ASM := Re2;
   end;
end;


function AddThousandSep(l : longint) : string;
var
  b : byte;
  pst1, pst2 : str16;
begin
  pst2 := '';
  str(l, pst1);
  b := length(pst1);

  while (b > 3) do
   begin
    pst2 := '.' + copy(pst1, b-2, 3) + pst2;
    pst1 := copy(pst1, 1, b-3);
    dec(b, 3);
   end;

  AddThousandSep := pst1 + pst2;
end;


function AS2Spac(Re1 : string) : string;
var
  by, b1 : byte;
  Re2, pst : string;
begin

if Re1[2] = '_' then
 re2 := '';

  re2 := '';

  if (short(Re1) = '') then AS2Spac := ''
   else

  if (Re1[1] = ';') then AS2Spac := Re1 else
   begin
    if (Re1[1] in [' ', #9]) then
     begin
      Re1 := short(Re1);
      Re2 := blank(16);
     end
      else

    if (Re1[1] <> '.') then
     begin
      by := 0;
      while (not (Re1[by+1] in [' ', #9]) and (by < length(Re1))) do inc(by);
      Re2 := copy(Re1, 1, by);
      Delete(Re1, 1, by);
      Re1 := short(Re1);
      while (length(Re2) < 16) do Re2 := Re2 + ' ';
      if (Re2[16] <> ' ') then Re2 := Re2 + ' ';
     end;

    if (Re1[1] = '.') then
     begin
      if (upper(copy(Re1, 2, 2)) = 'EQ') then
       begin
        Re2 := Re2 + '.eq ';
        delete(Re1, 1, 3);
        Re1 := short(Re1);
        by := 0;

        while     (not (Re1[by+1] in [' ', #9, '='])
              and (by < length(Re1))) do inc(by);

        Re2 := Re2 + copy(Re1, 1, by) + ' ';
        while (length(Re2) < 16) do Re2 := Re2 + ' ';
        Re2 := Re2 + '= ';
        delete(Re1, 1, by);
        Re1 := short(Re1);

{**  Look for '='  **}
        by := 1;
        while (Re1[by] <> '=') and (by < length(Re1)) do inc(by);
        delete(Re1, 1, by);
        Re1 := short(Re1);

        by := 0;
        while     (not (Re1[by+1] in [' ', #9])
              and (by < length(Re1))) do inc(by);
        Re2 := Re2 + copy(Re1, 1, by) + ' ';
        Delete(Re1, 1, by+1);
        Re1 := short(Re1);

        if (Re1 = '') then
         begin
          AS2Spac := Re2;
          exit;
         end;
       end
      else
       begin
        by := 0;

        repeat
         while (    not (Re1[by+1] in ['''', '"', ';'])
                and (by < length(Re1))) do inc(by);

         if (Re1[by+1] = '''') then
          while (Re1[by+1] <>  '''') and (by < length(Re1)) do inc(by)
           else
         if (Re1[by+1] = '"') then
          while (Re1[by+1] <>  '"') and (by < length(Re1)) do inc(by)
        until (Re1[by+1] = ';') or (by = length(Re1));


        Re2 := Re2 + copy(Re1, 1, by) + ' ';
        while (Re2[length(Re2)] in [' ', #9]) do Re2[0] := pred(Re2[0]);
        Re2 := Re2 + ' ';
        Delete(Re1, 1, by);
       end;
     end
      else

{**  Opcode  **}
    if (Re1[1] <> ';') then
     begin
      by := 0;
      while (not (Re1[by+1] in [' ', #9]) and (by < length(Re1))) do inc(by);
      pst := upper(copy(Re1, 1, by));

      for b1 := 1 to length(pst) do
       if (pst[b1] in ['A'..'Z']) then pst[b1] := chr(ord(pst[b1]) + 32);

      Re2 := Re2 + pst + ' ';
      Delete(Re1, 1, by);
      Re1 := short(Re1);
     end;

{**  Operand  **}
    if (Re1[1] <> ';') and (Re1 <> '') then
     begin
      while (length(Re2) < 24) do Re2 := Re2 + ' ';
      by := 0;

      repeat
       while (    not (Re1[by+1] in [' ', #9, '''', '"', ';'])
              and (by < length(Re1))) do inc(by);

       if (Re1[by+1] = '''') then
        while (Re1[by+1] <>  '''') and (by < length(Re1)) do inc(by)
         else
       if (Re1[by+1] = '"') then
        while (Re1[by+1] <>  '"') and (by < length(Re1)) do inc(by)
      until (Re1[by+1] in [' ', #9, ';']) or (by = length(Re1));

      Re2 := Re2 + copy(Re1, 1, by) + ' ';
      Delete(Re1, 1, by);
      Re1 := short(Re1);
     end;

    if (Re1[1] = ';') and (Re1 <> '') then
     begin
      while (length(Re2) < 40) do Re2 := Re2 + ' ';
      if (Re2[40] <> ' ') then Re2 := Re2 + ' ';
      Re2 := Re2 + Re1;
     end;

    AS2Spac := Re2;
   end;
end;


function BIOSCOM(COMNo : Word) : Word;   { 1=COM1 to 4=COM4 }
{-----------------------------------------------------------------------------
Determines I/O-address of given COM-port.
in:     Number of port
out:    I/O-address
-----------------------------------------------------------------------------}
begin
  Case COMNo of
   1 : BIOSCOM := MemW[SEG0040:$0008];
   2 : BIOSCOM := MemW[SEG0040:$000A];
   3 : BIOSCOM := MemW[SEG0040:$000C];
   4 : BIOSCOM := MemW[SEG0040:$000E];
   else BIOSCOM := 0;
  end;
end;


function BIOSLPT(LPTNo : Word) : Word;   { 1=LPT1 to 4=LPT4 }
{-----------------------------------------------------------------------------
Determines I/O-address of given LPT-port.
in:     Number of port
out:    I/O-address
-----------------------------------------------------------------------------}
begin
  Case LPTNo of
   1 : BIOSLPT := MemW[SEG0040:$0008];
   2 : BIOSLPT := MemW[SEG0040:$000A];
   3 : BIOSLPT := MemW[SEG0040:$000C];
   4 : BIOSLPT := MemW[SEG0040:$000E];
   else BIOSLPT := 0;
  end;
end;


function Blank(N:Integer):String;
var S:String;
begin
  if N > 255 then N := 255;
  S := '';
  while length(S) < N do S := S + ' ';
  Blank := S;
end;


function Byte2Bit(pby : byte):string;
var
  i : integer;
  bitpat : string[8];
begin
  bitpat:='        ';
  for i := 0 to 7 do
   if (pby and Power2[i] = Power2[i]) then
    bitpat[8-i]:='1' else bitpat[8-i]:='0';
  Byte2Bit:=bitpat;
end;

function CenterTxt(pst : string; bs, be : byte) : string;
{-----------------------------------------------------------------------------
Centers given text in given area
in:  pst : text
     bs  : relative start
     be  : relative end
out: Complete string
-----------------------------------------------------------------------------}
var
  bl : byte;
begin
  bl := length(pst);
  if (bl > be - bs) then CenterTxt := pst
   else CenterTxt := Blank((be - bs - bl) div 2) + pst + Blank((be - bs - bl) div 2);
end;


function CutExtension(pst : string) : string;
{-----------------------------------------------------------------------------
Cut extension including point
in:  Name of file
out: Name of file minus extension
-----------------------------------------------------------------------------}
var
  b1, b2 : byte;
begin
  b1 := length(pst);
  b2 := RightPos(chSep, pst);
  while ((b1 > b2) and (pst[b1] <> '.')) do dec(b1);
  if b1 = b2 then CutExtension := pst else
   CutExtension := copy(pst, 1, b1-1);
end;


function Dec2Bit(plo : longint; pby2 : byte) : string;
var
  pby : byte;
  pst : string;
begin
  if plo > $FFFFFF then
   begin
    Dec2Bit := '';
    exit;
   end;

  pby := plo div 65536;
  pst := Byte2Bit(pby);
  plo := plo mod 65536;
  pby := plo div 256;
  pst := pst+Byte2Bit(pby);
  plo := plo mod 256;
  pst := pst+Byte2Bit(plo mod 256);

  delete(pst, 1, length(pst) - pby2);
  Dec2Bit:=short(pst);
end;


function Dec2hex(plo:longint; pby2:byte) : str80;
var
  pby : byte;
  pst  : string;

 function hex_to_asc(pby:byte) : Str2;
 const
  hexd : array[0..15] of char='0123456789ABCDEF';
 begin
  hex_to_asc := hexd[pby shr 4] + hexd[pby and 15];
 end;

begin
  pst := hex_to_asc((plo shr 24) and $FF) + hex_to_asc((plo shr 16) and $FF)
       + hex_to_asc((plo shr 8) and $FF) + hex_to_asc(plo and $FF);

  pby := 1;
  while ((pst[pby]='0') and (pby<length(pst)-pby2+1) and (pby<length(pst))) do
   begin
    pst[pby] := ' ';
    inc(pby);
   end;
  if pby2=0 then pst := short(pst)
   else pst := copy(pst,ord(pst[0])-pby2+1,pby2);
  Dec2hex := pst;
end;


function Dirname2ext(filenaam:string) : string;
var b : byte;
begin
  b := pos('.', filenaam);
  if (b = 0) then Dirname2ext := ''
   else Dirname2ext := copy(filenaam, b+1, 3);
end;


function Dirname2name(filenaam:string) : string;
var b : byte;
begin
  b := pos('.', filenaam);
  if (b = 0) then Dirname2name := filenaam
   else Dirname2name := copy(filenaam, 1, b-1);
end;


function DriveValid(Drive: Char): Boolean;
{------------------------------------------------------------------------------
Checks if the specified drive exists
In : Drive: the letter or device number of the drive
Out: True = the drive exists
-----------------------------------------------------------------------------}
var
  TBuf : array[0..255] of byte;
  S    : array[0..2] of Char;
  pbo  : boolean;
  Regs : Registers;
begin
  S[0] := Drive;
  S[1] := ':';
  S[2] := #0;

  with Regs do
   begin
    AX := $2900;
    DS := Seg(S);
    SI := Ofs(S);
    ES := Seg(TBuf);
    DI := Ofs(TBuf);
    MSDOS(Regs);
    pbo := (AL = 0);
   end;

  if (pbo and (Drive in ['A', 'B'])) then
   begin
 asm
       mov al, Drive;
       sub al, 'A' - 1;
       mov bl, al;
       mov bh, 3;
       sub bh, bl;
       mov ax, $440E;
       int $21;
       jnc @1;
       xor al, al;
   @1: cmp al, bh;
       jne @2;
       mov pbo, False;
   @2:
 end;
   end;

  DriveValid := pbo;
end;

function DT2Date(dt : DateTime) : string;
begin
  with dt do
   if (DateFormat = 0) then
    begin
     DT2Date := (LeadingZero(Month) + DateSep + LeadingZero(Day)
      + DateSep + LeadingZero(Year mod 100));
    end
     else
   if (DateFormat = 1) then
    begin
     DT2Date := (LeadingZero(Day) + DateSep + LeadingZero(Month)
      + DateSep + LeadingZero(Year mod 100));
    end
     else
   if (DateFormat = 2) then
    begin
     DT2Date := (LeadingZero(Year mod 100) + DateSep + LeadingZero(Month)
      + DateSep + LeadingZero(Day));
    end;
end;


function DT2Time(dt : DateTime) : string;
begin
  with dt do
   DT2Time := (LeadingZero(Hour) + TimeSep + LeadingZero(Min)
      + TimeSep + LeadingZero(Sec));
end;


function exists(filenaam : string) : boolean;
{----------------------------------------------------------------------------
Checks if a file exists.
in:     Filename
out:    Yes/No
----------------------------------------------------------------------------}
var
  f : text;
begin
  exists := false;
  assign(f, filenaam);
  {$I-} reset(f); {$I+}
  if (ioresult <> 0) then exit;
  exists := true;
  close(f);
end;


function FastDisk : char;
{----------------------------------------------------------------------------
Searches for fastest disk by measuring read/write speed.
in:     -
out:    Fastest disk
----------------------------------------------------------------------------}
var
  b, c, d : byte;
  fb : file of byte;
  lT1, lt2 : longint;
begin
  lT1 := 0;
  for c := ord('C') to ord('Z') do
   begin

    assign(fb, chr(c) + ':\RB_UNIT2.000');
    {$I-} rewrite(fb); {$I+}
    if (IOresult <> 0) then break;

   {*  Wait for new tick of DOS clock  *}
    b := mem[$0040:$006C];
    repeat until (b <> mem[$0040:$006C]);
    b := mem[$0040:$006C];

    repeat
     write(fb, b);
    until (mem[$0040:$006C] <> b);

    {$I-} reset(fb); {$I+}
    if (IOresult <> 0) then break;

    lT2 := FileSize(fb);

    if (lT2 > lT1) then
     begin
      lT1 := lT2;
      d := c;
     end;

    close(fb);
    erase(fb);
   end;

  FastDisk := chr(d);
end;


function File2drive(filenaam:string) : char;
begin
  if pos(':', filenaam) = 2 then
   File2drive := Filenaam[1]
    else
   File2drive := #0;
end;


function File2ext(filenaam:string) : string;
var b : byte;
begin
  if pos('.', filenaam) = 0 then
   File2ext := ''
    else
   begin
    b := length(filenaam);
    while ((b > 1) and not (filenaam[b] in[chSep, '.'])) do dec(b);
    if (filenaam[b] <> '.') then
     File2ext := ''
      else
     File2ext := copy(filenaam, b+1, length(filenaam) - b);
   end;
end;


function  File2Fname(filenaam:string) : string;
var b : byte;
begin
  b := RightPos(chSep, filenaam);
  if (b = 0) then File2Fname := filenaam else
   File2Fname := copy(filenaam, b+1, length(filenaam) - b - 1);
end;


function  File2name(filenaam:string) : string;
var b, c : byte;
begin
  b := length(filenaam);
  while ((b > 0) and not (filenaam[b] in [chSep, '.'])) do dec(b);
  if (filenaam[b] <> '.') then
   File2name := copy(filenaam, b+1, length(filenaam) - b)
    else
   begin
    c := b;
    while ((b > 0) and not (filenaam[b] = chSep)) do dec(b);
    File2name := copy(filenaam, b+1, c - b - 1);
   end;
end;


function  File2path(filenaam:string) : string;
var b : byte;
begin
  b := length(filenaam);
  while ((b > 0) and not (filenaam[b] = chSep)) do dec(b);
  if (b = 0) then
   File2path := ''
    else
   begin
    if (filenaam[2] = ':') then
     File2path := copy(filenaam, 3, b-2)
      else
     File2path := copy(filenaam, 1, b);
   end;
end;


function fzin(w:word):string;
begin
  case w of
   99 : fzin := '';
     else fzin := '?????????';
  end;
end;


function GetCursorMode: word;
{-----------------------------------------------------------------------------
Gets shape of current cursor (if any)

This function gets the old cursor descriptor. It is important to note
that while ALL video adapters will turn off the cursor in response to
the value $0F0F, different values which turn them on make different
shapes (in particular, the Hercules card behaves differently from the
IBM mono adapter). To be safe, always put in a value you have retrieved
previously to turn the cursor on.
-----------------------------------------------------------------------------}
var
  Regs         : Registers;              {IBM PC Registers}
begin
  Regs.AX := $0300;
  Intr($10,Regs);
  GetCursorMode := Regs.CX;
end;


function GetDateTime : longint;
var
  dt : DateTime;
  plo : longint;
  h, m, s, hu, y, mo, d, wd : word;
begin
  GetTime(h, m, s, hu);
  GetDate(y, mo, d, wd);
  with dt do
   begin
    Year := y;
    Month := mo;
    Day := d;
    Hour := h;
    Min := m;
    Sec := s;
    PackTime(dt, plo);
   end;
  GetDateTime := plo;
end;


function GetHexDateTime : Str16;
begin
  GetHexDateTime := Dec2Hex(GetDateTime, 8);
end;


function GetScreenHeight: byte;
{---------------------------------------------------------------------------
Determines number of lines on textscreen
---------------------------------------------------------------------------}
var
  pIm, by : byte;
  Regs : Registers;
begin
  TPushImage(pIm);
  ClrScr;

  for by := 1 to 100 do writeln;

  with Regs do
   begin
    AH := 3;
    BH := 0;
    intr($10, Regs);

    GetScreenHeight := DH + 1;
   end;

  TPopImage(pIm);
end;


Function Int2Str(I : Longint) : String;
Var Result : String;
begin
  Str(I, Result);
  Int2Str := Result;
end;


function IsVGA : boolean;
{ Checks if VGA is present }
var Regs : Registers;
begin
  Regs.AX := $1A00;
  Intr( $10, Regs );
  if ( Regs.AL = $1A ) then IsVga := true else IsVga := false;
end;


function LeadingZero(w : Word) : String;
var s : String;
begin
  Str(w:0, s);
  if (w < 10) then s := '0' + s;
  LeadingZero := s;
end;


function LeadingZeros(w, t : Word) : String;
var s : String;
begin
  Str(w:0, s);
  while length(s) < t do s := '0' + s;
  LeadingZeros := s;
end;


function lengte(Regel : string) : word;
var
  w : word;
  pst : string;
begin
  pst := '';
  w := 1;

  while (w <= length(Regel)) do
   begin
    if (Regel[w] <> #9) then pst := pst + Regel[w] else
     begin
      pst := pst + ' ';
      while (length(pst) mod 8 > 0) do pst := pst + ' ';
     end;

    inc(w);
   end;

  lengte := length(pst);
end;


function lower(s:string) : string;
{----------------------------------------------------------------------------
Returns a string where all characters are non-capital (if possible).
in:     string
out:    string
----------------------------------------------------------------------------}
var  t : byte;
begin
  for t:=1 to length(s) do
   if (s[t] in ['A'..'Z']) then s[t] := chr(ord(s[t]) or 32);
  lower:=s;
end;


function Lshort(pst:string):string;
{----------------------------------------------------------------------------
SHORT eliminates Blank at the beginning and end of a string.
     '  abcd efgh   ' -> 'abcd efgh   '
in:     string
out:    updated string
----------------------------------------------------------------------------}
begin
  if (pst <> '') then
   while pst[1] in [' ', #9, #10, #13] do delete(pst, 1, 1);
  Lshort := pst;
end;


function ml(pst:string; m:byte; pbo:boolean):string;
{---------------------------------------------------------------------------
Adds spaces to string PST until length of string is M bytes.
if PBO is True, spaces are added at end of string.
if PBO is False, spaces are added at beginning of string.
---------------------------------------------------------------------------}
begin
  if pbo then while length(pst)<m do pst:=pst+' '
    else while length(pst)<m do pst:=' '+pst;
  ml:=pst;
end;


function  NoSpace(pst : string) : string;
var
  i : integer;
  s : string;
begin
  s := '';
  for i := 1 to length(pst) do
   if not(pst[i] in [#9, ' ']) then s := s + pst[i];
  NoSpace := s;
end;


function ReadKeyboard : char;
{----------------------------------------------------------------------------
Reads input of keyboard, #0-keys like function keys are transformed to a code
  between 127 and 255
in:     -
out:    Charcode
----------------------------------------------------------------------------}
var
  c : char;
begin
  c := ReadKey;
  if c = #0 then
   begin
    c := ReadKey;
    c := chr(128 + ord(c));
   end;
  ReadKeyboard := c;
end;


function RightPos(C: Char; const S: string): Byte; assembler;
{----------------------------------------------------------------------------
Works like pos but starts at right side of string
Author: Joe Foster (Star Commander)
----------------------------------------------------------------------------}
asm
    les di, S;
    mov al, es:[di];
    xor ah, ah;
    mov cx, ax;
    jcxz @1;
    add di, cx;
    mov al, C;
    std;
    repne scasb;
    jne @1;
    inc cx;
@1: mov ax, cx;
end;


function RightPosSt(C: string; const S: string): Byte;
var
  b1, b2, b3, b4 : byte;
  pst : string;
begin
  pst := S;
  b1 := pos(C, pst);

  if (b1 > 0) then
   begin
    b2 := 0;
    b3 := length(C);
    while (b1 > 0) do
     begin
      b4 := b1 + b3;
      b2 := b2 + b4 - 1;
      pst := copy(pst, b4, length(pst) - b4 + 1);
      b1 := pos(C, pst);
     end;
    b1 := b2 - b3 + 1;
   end;
  RightPosSt := b1;
end;


function Rshort(pst:string):string;
{----------------------------------------------------------------------------
SHORT eliminates Blank at the end of a string.
     '  abcd efgh   ' -> '  abcd efgh'
in:     string
out:    updated string
----------------------------------------------------------------------------}
begin
  if (pst <> '') then
   while pst[length(pst)] in [' ', #9, #10, #13] do pst[0]:=pred(pst[0]);
  Rshort := pst;
end;


function Short(pst:string):string;
{----------------------------------------------------------------------------
SHORT eliminates Blank at the beginning and end of a string.
     '  abcd efgh   ' -> 'abcd efgh'
in:     string
out:    updated string
----------------------------------------------------------------------------}
begin
  if (pst <> '') then
   while pst[length(pst)] in [' ', #9, #10, #13] do pst[0]:=pred(pst[0]);
  if (pst <> '') then
   while pst[1] in [' ', #9, #10, #13] do delete(pst, 1, 1);
  short := pst;
end;


function stDate : string;
var sD, sM, sY, sW : str2;
begin
  GetSDate(sD, sM, sY, sW);
  if (DateFormat = 0) then stDate := sM + DateSep + sD + DateSep + sY
    else
  if (DateFormat = 1) then stDate := sD + DateSep + sM + DateSep + sY
    else
  if (DateFormat = 2) then stDate := sY + DateSep + sM + DateSep + sD ;
end;


function stTime : string;
var sH, sM, sS, sW : str2;
begin
  GetSTime(sH, sM, sS, sW);
  stTime := sH + TimeSep + sM + TimeSep + sS;
end;


function stTime2 : string;
var sH, sM, sS, sW : str2;
begin
  GetSTime(sH, sM, sS, sW);
  stTime2 := sH + TimeSep + sM + TimeSep + sS + TimeSep + sW;
end;


function tChooseItem(var tit : t_item) : Str80;
var
  pbo : boolean;
  ft1 : file of Str80;
  pw1,pi1,pin,ry, iMax : integer;
  pr : real;
  ask_look, pst1, pst2, Choice : str80;
  ramm : t_graph;
  show : t_menu;
  po : t_one;
begin
with tit do
 begin
  tChooseItem := '';
  assign(ft1, _Filename);
  {$I-} reset(ft1); {$I+}
  if (IOresult <> 0) then exit;
  show._ar := filesize(ft1);


{**  Search for longest item in list  **}
  pin:=0;
  pst2 := '';
  while not EOF(ft1) do
   begin
    read(ft1, pst1);
    if (length(pst1) > length(pst2)) then
     begin
      pst2 := pst1;
      pin := length(pst2);
     end;
   end;

  with po do
   begin
    _kop := _itkop;
    _qu := '';
    _sl := pin;
    Beeep;
    tAsk_one(po);

    ask_look := _qu;

    if (_bLastKey = 27) then
     begin
      tChooseItem := #27;
      exit;
     end;
   end;


{**  use only whole word  **}
  pw1:=1;
  while ((ask_look[pw1] <> ' ') and (pw1 <= length(ask_look))) do inc(pw1);
  ask_look[0] := chr(pw1 - 1);
  ask_look := ml(ask_look, pin, true);

  with show do
   begin
    _FileName := tit._Filename;
    _hl := '';
    _li := blank(pin);
    _mk := 98;
    _mu := false;
   end;

  with ramm do
   begin
    _y1 := 5;
    _y2 := MaxY - 3;
    _kt := _itkop;
    _pi := 1;
    _so := _itso;
   end;
  tshowbaseline('Esc = Back / stop                   '+chr(24)+' '+chr(25));


{**  Search list  **}
  pbo := false;
  pi1 := 0;
  reset(ft1);
  repeat
   read(ft1, pst1);
   pst2 := ml(pst1, pin, true);
   if (upper(ask_look) <= upper(pst2)) then pbo:=true;
   inc(pi1);
  until (EOF(ft1) or pbo);
  dec(pi1);

  close(ft1);

  show._hl := short(pst2);
  tChooseItem := tlistmenu(show,ramm);
 end;
end;


function tListMenu(var lm : t_menu; var pgr : t_graph) : Str80;
{----------------------------------------------------------------------------
IN:  pgr._Y1 : Upper limit window
     pgr._Y2 : Lowest limit window
----------------------------------------------------------------------------}
var
  bMaxAr, bPtr, b1 : byte;
  C : char;
  ft1 : file of Str80;
  l,y,t,ry,ylen,tx : integer;
  lT1, lT2, lHL : longint;
  pst, Choice : Str80;

 procedure Down;
 begin
  if (bPtr > bMaxAr div 2) then
   begin
    if (bPtr < bMaxAr-1) then inc(bPtr);
   end
    else
  if (bPtr = bMaxAr div 2) then
   begin
    if (lT1 < lm._ar - 1 - bMaxAr) then inc(lT1) else
     if (bPtr < bMaxAr-1) then inc(bPtr);
   end
    else inc(bPtr);
 end;

 procedure Up;
 begin
  if (bPtr > bMaxAr div 2) then dec(bPtr) else
  if (bPtr = bMaxAr div 2) then
   begin
    if (lT1 > 0) then dec(lT1) else
     if (bPtr > 0) then dec(bPtr);
   end
    else
  if (bPtr > 0) then dec(bPtr);
 end;

begin
  with lm do with pgr do
   begin
    tListMenu := '';
    if MouseActive then MouseOff;
    l := length(_kt);

    assign(ft1, _Filename);
    {$I-} reset(ft1); {$I+}
    if (IOresult <> 0) then exit;
    _ar := filesize(ft1);

    lHL := 0;
    for t := 0 to _ar-1 do
     begin
      read(ft1, pst);
      if (length(pst) > l) then l := length(pst);
      if (upper(pst) < upper(_hl)) then inc(lHL);
     end;

    _x1 := ((MaxX - l) div 2) - 2;
    _x2 := _x1 + l + 4;

    bMaxAr := _y2 - _y1 - 3;
    while (_ar < _y2 - _y1 - 3) do
     begin
      dec(_y2);
      if (_ar < _y2 - _y1 - 3) then inc(_y1);
     end;
    if (_ar < bMaxAr) then bMaxAr := _ar;

    _so := _so and $FD;
    traam(pgr);

    inc(pgr._x1, 2);
    ry := pgr._y1 + 3;


  {**  Should list start from begin?  **}
    if (_HL = '') then
     begin
      bPtr := 0;
      lT1 := 0;
     end
      else
     begin
      if (_ar > bMaxAr) then
       begin
        if (lHL <= bMaxAr div 2) then
         begin
          bPtr := lHL;
          lT1 := 0;
         end
          else
        if (lHL >= _ar - (bMaxAr div 2)) then
         begin
          bPtr := _ar - (bMaxAr div 2);
          lT1 := _ar - bMaxAr;
         end
          else
         begin
          bPtr := (bMaxAr div 2);
          lT1 := lHL - (bMaxAr div 2);
         end;
       end
        else
       begin
        bPtr := lHL;
        lT1 := 0;
       end;
     end;

    _oc := ' ';
    repeat
     _y1 := ry;
     seek(ft1, lT1);
     lT2 := 0;
     repeat
      read(ft1, _kt);
      if (bPtr = lT2) then
       begin
        _so:=1;
        Choice := short(_kt);
       end
        else _so:=0;
      tgwrite(pgr);
      inc(_y1);
      inc(lT2);
     until (lT2 = bMaxAr);


     c := ReadKeyboard;

     if (c = #200) then Up else                   { up }
     if (c = #208) then Down else                 { down }
     if (c = #201) then                           { Page up }
      begin
       for b1 := 1 to 10 do Up;
      end
       else
     if (c = #209) then                           { Page down }
      begin
       for b1 := 1 to 10 do Down;
      end;

     WaitKey;
    until (c in [#13, #27]);
    tpopimage(pgr._pi);

    if MouseActive then MouseOn;

    close(ft1);

    if (c = #27) then tListMenu := '' + #27
     else tListMenu := Choice;
   end;
end;


function upper(s:string) : string;
{----------------------------------------------------------------------------
Returns a string where all characters are capital (if possible).
in:     string
out:    string
----------------------------------------------------------------------------}
var  b : byte;
begin
  for b:=1 to ord(s[0]) do s[b]:=Upcase(s[b]);
  upper:=s;
end;


function RB_Zin(b : byte) : Str80;
begin
  case b of
    1 : RB_Zin := 'Esc = Back / Stop                 '#24' '#25;
      else RB_Zin := #7'???????';
  end;
end;


{============================================================================}


procedure Beeep;
begin
{
  sound(3000);
  delay(100);
  nosound;
}
end;


procedure ClrWindow;
begin
  Window(1,1,maxx,maxy);
  TextBackground(Black);
  textcolor(lightgray);
  ClrScr;
end;


procedure CursorOff;
var regs:registers;
begin
 regs.CH := $20;
 regs.CL := $20;
 regs.AH := $01;
 intr($10,regs);
end;


procedure CursorOn;
var regs:registers;
begin
  if lastmode=7 then
   begin
    regs.CH := 12;
    regs.CL := 13;
   end
    else
   begin
    regs.CH := 6;
    regs.CL := 7;
   end;
 regs.AH := $01;
 intr($10,regs);
end;


procedure DeleteS(var pst : string; i, c : integer);
begin
  delete(pst, i, c);
  pst := short(pst);
end;


procedure GetSDate(var sD, sM, sY, sW : str2);
var w1, w2, w3, w4 : word;
begin
  getdate(w1, w2, w3, w4);
  sY := LeadingZero(w1 mod 100);
  sM := LeadingZero(w2);
  sD := LeadingZero(w3);
  sW := LeadingZero(w4);
end;


procedure GetSTime(var sH, sM, sS, sW : str2);
var w1, w2, w3, w4 : word;
begin
  gettime(w1, w2, w3, w4);
  sH := LeadingZero(w1);
  sM := LeadingZero(w2);
  sS := LeadingZero(w3);
  sW := LeadingZero(w4);
end;


procedure InitCountry;
{-----------------------------------------------------------------------------
Initialize country-dependent information
-----------------------------------------------------------------------------}
var
  TBuf : array[0..$2F] of byte;
  regs:registers;
begin
  with Regs do
   begin
    DX := Ofs(TBuf);
    AX := Seg(TBuf);
    DS := AX;
    AX := $3800;
    intr($21, Regs);
   end;
  DateFormat := TBuf[0];
  ThousandSep := chr(TBuf[7]);
  DateSep := chr(TBuf[11]);
  TimeSep := chr(TBuf[13]);
end;


procedure MWrite(pst : str80; width : byte);
begin
  gotoXY((width - length(pst)) div 2, whereY);
  write(pst);
end;


procedure MWriteln(pst : str80; width : byte);
begin
  gotoXY((width - length(pst)) div 2, whereY);
  writeln(pst);
end;


procedure Place(x,y,c:byte);
begin
  gotoxy(x,y); write(chr(c));
end;


procedure Place2(x,y,c:byte);
var
  Regs : Registers;
begin
  gotoxy(x,y);
  with Regs do
   begin
    AH := 8;
    BH := 0;
    intr($10,regs);             { get attribute }

    BL := AH;
    BH := 0;
    AH := 9;
    AL := c;
    CX := 1;
    intr($10,regs);             { place char }
   end;
end;


procedure PWait(w : word);
begin
  while (w > 0) do
   begin
 asm
   mov  AX, 12
   call Wait
 end;
    dec(w);
   end;
end;


procedure RK;
var c : char;
begin
  repeat until KeyPressed;
  c := ReadKey;
end;


procedure SetCursorMode(Mode : word);
{-----------------------------------------------------------------------------
Sets shape of current cursor (if any)
-----------------------------------------------------------------------------}
var
  Regs         : Registers;              {IBM PC Registers}
begin
  Regs.AX := $100;
  Regs.CX := $10;
  Intr($10,Regs);
end;


procedure SetWindowDefaults(WriteFile:boolean; Mode:word);
type
  Kleur=record
    C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15
     ,C16,C17,C18,C19,C20,C21,C22,C23,C24,C25,C26,C27,C28 : byte;
   end;

var
  bo : boolean;
  sv : Kleur;
  sf : file of Kleur;
begin
  bo := false;
  assign(sf,'Colors.cfg');
  {$I-} reset(sf); {$I+}
  if IOresult <> 0 then bo := true;
  {$I-} read(sf,sv); {$I+}
  if IOresult <> 0 then bo := true;
  {$I-} close(sf); {$I+}
  if IOresult <> 0 then bo := true;

  if bo = true then
   begin
    if ((Mode = 0) or (Mode = 2) or (Mode = 7)) then
     begin
      sv.C1  := white;  {Menu-border}
      sv.C2  := black;  {Background title}
      sv.C3  := black;  {Background window}
      sv.C4  := 7    ;  {Text}
      sv.C5  := black;  {Highlighted bar}
      sv.C6  := 15   ;  {Text in bar}
      sv.C7  := 15   ;  {Highlighted character}
      sv.C8  := white;  {Text message-line}
      sv.C9  := black;  {Background message-line}
      sv.C10 := black;  {Background border}
      sv.C11 := white;
      sv.C12 := black;
      sv.C13 := white;
      sv.C14 := LightGray;
      sv.C15 := Black;
      sv.C16 := White;
      sv.C17 := Black;
      sv.C18 := Black;
      sv.C19 := Lightgray;
      sv.C20 := White;
      sv.C21 := Black;
      sv.C22 := White;
      sv.C23 := Lightgray;
      sv.C24 := Black;
      sv.C25 := White + blink;
      sv.C26 := White;
      sv.C27 := Lightgray;
      sv.C28 := Black;

      if Mode = 7 then
       begin
        sv.C3 := 1    ;  {Background window}
        sv.C5 := 7    ;  {Highlighted bar}
        sv.C6 := 0    ;  {Text in bar}
        sv.C7 := 8    ;  {Highlighted character}
       end;
     end
    else
     begin
      sv.C1  := yellow;    {Menu-border}
      sv.C2  := blue;      {Background title}
      sv.C3  := lightgray; {Background window}
      sv.C4  := lightblue; {Text}
      sv.C5  := cyan;      {Highlighted bar}
      sv.C6  := white;     {Text in bar}
      sv.C7  := red;       {Highlighted character}
      sv.C8  := white;     {Text message-line}
      sv.C9  := blue;      {Background message-line}
      sv.C10 := green;     {Background border}
      sv.C11 := white;
      sv.C12 := black;
      sv.C13 := white;
      sv.C14 := LightGray;
      sv.C15 := Cyan;
      sv.C16 := White;
      sv.C17 := Black;
      sv.C18 := Cyan;
      sv.C19 := White;
      sv.C20 := Yellow;
      sv.C21 := Black;
      sv.C22 := White;
      sv.C23 := Lightgray;
      sv.C24 := Red;
      sv.C25 := White;
      sv.C26 := White;
      sv.C27 := Lightgray;
      sv.C28 := Black;
     end;

    if WriteFile then
     begin
      rewrite(sf);
      write(sf,sv);
      close(sf);
     end;
   end;

  klPanBorder   := sv.C1;
  klPanHeadBck  := sv.C2;
  klPanBckgnd   := sv.C3;
  klPanTxt      := sv.C4;
  klPanHighBck  := sv.C5;
  klPanHighTxt  := sv.C6;
  klPanChar     := sv.C7;
  klMessage     := sv.C8;
  klMessageBck  := sv.C9;
  klPanBordBck  := sv.C10;
  klPanHead     := sv.C11;
  klMenuBckgnd  := sv.C12;
  klMenuTxt     := sv.C13;

  klQueBckgnd   := sv.C14;
  klQueHighBck  := sv.C15;
  klQueHighTxt  := sv.C16;
  klQueTxt      := sv.C17;

  klSMenuBckgnd := sv.C18;
  klSMenuTxt    := sv.C19;
  klSMenuChoice := sv.C20;
  klSMenuHighBck:= sv.C21;
  klSMenuHighTxt:= sv.C22;
  klSMenuBorder := sv.C23;

  klErrBckgnd   := sv.C24;
  klErrHeadTxt  := sv.C25;
  klErrTxt      := sv.C26;
  klErrHighBck  := sv.C27;
  klErrHighTxt  := sv.C28;
end;


procedure sort_ar(Fname : str80);
var
  b1, b2, b3 : byte;
  aStr80 : array[0..49] of Str80;
  ft1 : file of str80;
  lT1, lT2, lFSize : longint;
  pst, pst2 : Str80;
begin
  assign(Ft1, Fname);
  {$I-} reset(ft1); {$I+}
  if IOresult <> 0 then exit;
  lFSize := filesize(ft1);
  if (lFSize < 2) then exit;

  lT1 := 0;
  repeat
   b1 := 0;
   lT2 := 0;

for b2 := 0 to 49 do aStr80[b2] := '';

{**  Fill buffer  **}
   seek(ft1, lT1);
   while ((lT1 + lT2 < lFSize) and (b1 < 50)) do
    begin
     read(ft1, pst);
     aStr80[b1] := pst;
     inc(b1);
     inc(lT2);
    end;


{**  Sort buffer  **}
   b2 := 0;
   b3 := 1;
   while (b2 < b1-1) do
    begin
     while (b3 < b1) do
      begin
       if (aStr80[b3] < aStr80[b2]) then
        begin
         pst := aStr80[b2];
         aStr80[b2] := aStr80[b3];
         aStr80[b3] := pst;
        end;
       inc(b3);
      end;
     inc(b2);
     b3 := b2 + 1;
    end;


{**  If file > buffer, then check rest of file  **}
   while (lT1 + lT2 < lFSize) do
    begin
     read(ft1, pst);

     if (pst < aStr80[49]) then
      for b2 := 0 to 49 do
       begin
        if (pst < aStr80[b2]) then
         begin

  {**  if string in file < string in buffer....  **}
     {*  write last string to file  *}
          seek(ft1, lT1 + lT2);
          write(ft1, aStr80[49]);

     {*  Shift array  *}
          for b3 := 49 downto b2+1 do aStr80[b3] := aStr80[b3-1];
          aStr80[b2] := pst;                     { replace with new string }
          Break;
         end;
       end;

     inc(lT2);
    end;

{**  Buffer contains 50 lowest strings  **}
   seek(ft1, lT1);
   for b2 := 0 to b1-1 do write(ft1, aStr80[b2]); { write to buffer }
   inc(lT1, 50);
  until (lT1 >= lFSize);

  close(ft1);
end;


procedure tAsk(var ramm : t_graph; show : t_menu; var pask : t_ask);
type
  Str40 = String[40];
var
  _qu, _me : array[0..49] of Str40;
  fin : boolean;
  bPtr, bMaxAr, l, ry, b1, bX, bY, bx2 : byte;
  MenMax1, MenMax2 : integer;
  lT1, lT2, lT : longint;
  pst1, pst2 : Str80;
  Rec : t_instr;

 procedure Down;
 begin
  if (bPtr > bMaxAr div 2) then
   begin
    if (bPtr < bMaxAr) then inc(bPtr);
   end
    else
  if (bPtr = bMaxAr div 2) then
   begin
    if (lT1 < show._ar - 1 - bMaxAr) then inc(lT1) else
     if (bPtr < bMaxAr) then inc(bPtr);
   end
    else inc(bPtr);
 end;

 procedure Up;
 begin
  if (bPtr > bMaxAr div 2) then dec(bPtr) else
  if (bPtr = bMaxAr div 2) then
   begin
    if (lT1 > 0) then dec(lT1) else
     if (bPtr > 0) then dec(bPtr);
   end
    else
  if (bPtr > 0) then dec(bPtr);
 end;

begin
with ramm do with show do with pask do
 begin
  tshowBaseLine(RB_Zin(1));

  MenMax1 := 0;
  MenMax2 := 0;

  for l := 0 to _ar do
   begin
    if (Length(_me[l]) > MenMax1) then MenMax1 := Length(_me[l]);
    if (_le[l] > MenMax2) then MenMax2 := _le[l];
   end;

  while (MenMax1 + MenMax2 > MaxX - 6) do
   begin
    dec(MenMax1);
    dec(MenMax2);
   end;

  _x1 := MaxX div 2;
  _y1 := MaxY div 2;

  if (MenMax1 + MenMax2 < length(_kt)) then MenMax2 := length(_kt) - MenMax1;
  _x2 := MenMax1 + MenMax2 + 3;

  _y2 := _ar + 1;
  if (_y2 > MaxY - 6) then _y2 := MaxY - 6;
  bMaxAr := _y2 - 1;

  _so := (_so and $FC) or 2 ;
  traam(ramm);

  ry := ramm._y1 + 3;
  bX2 := ramm._x1;

  bPtr := 0;
  lT1 := 0;


  _oc := ' ';
  repeat
   _y1 := ry;
   lT2 := 0;
   repeat
    _x1 := bX2 + 2;
    _kt := _me[lT1 + lT2];
    if (bPtr = lT2) then
     begin
      _so:=1;
      bY := _y1;
      lT := lT1 + lT2;
     end
      else _so:=0;
    tgwrite(ramm);

    _kt := _qu[lT1 + lT2];
    _x1 := bX2 + 3 + MenMax1;
    if (bPtr = lT2) then bX := _x1;
    tgwrite(ramm);

    inc(_y1);
    inc(lT2);
   until (lT2 = bMaxAr + 1);

   gotoXY(bX, bY);
   Rec.stWhat := _tm[lT];
   Rec.stValidU := '';
   Rec.klActTxt := klQueHighTxt;
   Rec.klActBck := klQueHighBck;
   Rec.klNotActTxt := klQueTxt;
   Rec.klNotActBck := klQueBckgnd;
   Rec.stLine := _qu[lT];
   Rec.bLength := _le[lT];
   TInstr(Rec);

   _qu[lT] := Rec.stLine;

   _so := 0;
   _x1 := bX;
   _y1 := bY;
   _kt := ml(_qu[lT], _le[lT], True);
   tgwrite(ramm);

   _bLastKey := Rec.bLastKey;

   if (_bLastKey = 200) then Up else                   { up }
   if (_bLastKey = 208) then Down else                 { down }
   if (_bLastKey = 201) then                           { Page up }
    begin
     for b1 := 1 to 10 do Up;
    end
     else
   if (_bLastKey = 209) then                           { Page down }
    begin
     for b1 := 1 to 10 do Down;
    end;

   WaitKey;
  until (_bLastKey in [13, 27]);
  tpopimage(ramm._pi);

  if MouseActive then MouseOn;
 end;
end;


procedure Task_one(var po : t_one);
var
  tl : integer;
  ramm,r2:t_graph;
  Rec : t_instr;
begin
with po do
 begin
  if (_sl > 70) then _sl := 70;
  if (_sl > length(_kop)) then tl := _sl else tl := length(_kop);
  _qu := ml(_qu,_sl,true);
  with ramm do
   begin
    _x1 := MaxX div 2;
    _y1 := MaxY div 2;
    _x2 := tl+2;
    _y2 := 1;
    _kt :=_kop;
    _so := 6;
    _pi := 1;
    _oc := ' ';
   end;
  traam(ramm);

  with r2 do
   begin
    _x1 := (ramm._x1+ramm._x2) div 2-(_sl div 2)+1;
    _y1 := ramm._y1+3;
    _kt := _qu;
    _so := 0;
    _oc := ' ';
   end;
  tgwrite(r2);
  gotoxy(r2._x1, r2._y1);

  Rec.stWhat := 'ALPHA';
  Rec.stValidU := '';
  Rec.klActTxt := klQueHighTxt;
  Rec.klActBck := klQueHighBck;
  Rec.klNotActTxt := klQueTxt;
  Rec.klNotActBck := klQueHighBck;
  Rec.stLine := _qu;
  Rec.bLength := _sl;
  TInstr(Rec);

  _qu := Rec.stLine;
  _bLastKey := Rec.bLastKey;

  tpopimage(ramm._pi);
  textbackground(klPanBckgnd);
  textcolor(klPanTxt);
 end;
end;


procedure Tgwrite(var p_gwrite : t_graph);
var
  pb : boolean;
  ptl,ptl2 : word;
begin
  with p_gwrite do
   begin
    gotoxy(_x1,_y1);
    ptl := length(_kt);

    case _so of
     0 : textbackground(klPanBckgnd);
     1 : textbackground(klPanHighBck);
     2 : textbackground(_x2);
    end;

    pb := true;

    for ptl2 := 1 to ptl do
     begin
      if pb and (_kt[ptl2]=_oc) then
       begin
        TextColor(klPanChar);
        pb := false;
       end
      else
       case _so of
        0 : TextColor(klPanTxt);
        1 : TextColor(klPanHighTxt);
        2 : TextColor(_y2);
       end;

      write(_kt[ptl2]);
     end;
   end;
end;


procedure TInstr(var Rec : t_instr);
var
  Finish, ins, lock : boolean;
  c, v : char;
  x, y, let_num, i : integer;
  OldLine : str80;
  pst1,valida,template,valid : string;
  validh,validhs,validn,validi,validr : string[32];
label PL1;
begin
  CursorOn;

  with Rec do
   begin
    OldLine := stLine;
    lock := false;
    if (bLength < 1) or (bLength > 76) then bLength := 76;
    stLine := ml(stLine, bLength, True);

    validn  := ' 0123456789';
    validh  := '0123456789aAbBcCdDeEfF$';
    validhs := ' 0123456789aAbBcCdDeEfF$';
    validr  := ' 0123456789.E+-';
    validi  := ' 0123456789+-';
    valida  := '';
    for i := 32 to 254 do valida := valida+chr(i);

    template := '';
    pst1 := upper(stWhat);
    ins := False;
    lock := false;

    if pst1='NUM' then for i := 1 to bLength do template := template+'N' else
    if pst1='REAL' then for i := 1 to bLength do template := template+'R' else
    if pst1='INTEGER' then for i := 1 to bLength do template := template+'I' else
    if pst1='ALPHA' then for i := 1 to bLength do template := template+'A' else
    if pst1='HEX' then for i := 1 to bLength do template := template+'H' else
    if pst1='SHEX' then for i := 1 to bLength do template := template+'S' else
    if pst1='USER' then for i := 1 to bLength do template := template+'U' else
     begin
      lock := true;
      template := upper(stWhat);
      for i := 1 to bLength-length(stWhat) do template := template+'A';
     end;
    let_num := 1;

    x := wherex;
    y := wherey;

    textColor(klActTxt);
    Finish := False;

    repeat
     i := length(stLine);
     while ((stLine[i] = ' ') and (i > 0)) do dec(i);
     if i < let_num then i := let_num;
     stLine := copy(stLine, 1, i);
     stLine := ml(stLine, let_num-1, true);

     gotoxy(x, y);
     textbackground(klActBck);
     write(ml(stLine, bLength, true));
     gotoxy(x + (let_num - 1), y);

     v := ReadKeyboard;

     if (v in [#9, #13, #27, #143]) then Finish := True
      else
     if (v = #8) then                            { backspace }
      begin
       if not lock then
        stLine := copy(stLine, 1, let_num-2) + copy(stLine, let_num, bLength)
         else
       if template[let_num-1] in ['A','H','N','I','R','S','U'] then
        stLine := copy(stLine, 1, let_num-2) + ' ' + copy(stLine, let_num, bLength);

       if (let_num>1) then dec(let_num);
      end
     else

     if (ord(v) in [32..127]) then
      begin
       if template[let_num] in ['A','N','R','I','H','S','U'] then
        begin
         case template[let_num] of
          'A' : valid := valida;
          'N' : valid := validn;
          'H' : valid := validh;
          'S' : valid := validhs;
          'R' : valid := validr;
          'I' : valid := validi;
          'U' : valid := stValidU;
         end;

         if (pos(v, valid)<>0) then
          begin
           if ins then
            stLine := copy(copy(stLine, 1, let_num-1) + v
                       + copy(stLine, let_num, bLength), 1, bLength)
           else
            stLine := copy(stLine, 1, let_num-1) + v
                       + copy(stLine, let_num+1, bLength);
           goto PL1;
          end
         else Beeep;
        end
       else goto PL1;
      end
     else
      begin
       case v of
        #199 : let_num := 1;
        #200, #201, #208, #209 : Finish := true;
        #203 : begin
          if (let_num > 1) then dec(let_num);
          while (    not (template[let_num] in ['A','H','N','R','I','U','S'])
                 and (let_num>1)) do dec(let_num);
         end;
        #205 : begin
PL1:      if (let_num < bLength) then Inc(let_num);
          while (    not (template[let_num] in ['A','H','N','R','I','U','S'])
                 and (let_num<bLength)) do inc(let_num);
         end;
        #207 : begin
          let_num := Length(stLine)+1;
          if (let_num > bLength) then let_num := 1;
         end;
        #210 : if not lock then ins := not ins;
        #211 : if not lock then
         stLine := copy(stLine, 1, let_num-1) + copy(stLine, let_num+1, bLength);
       end;
      end;

     bLastKey := ord(v);
    until Finish;

    if (bLastKey = 27) then stLine := OldLine
     else stLine := short(stLine);

    stLine := ml(stLine, bLength, true);
    gotoxy(x, y);
    textbackground(klNotActBck);
    textcolor(klNotActTxt);
    write(stLine);
    stLine := short(stLine);
  end;

  CursorOff;
end;


procedure tMessage(pst : string);
var
  ramm : t_graph;
begin
  ramm._kt := pst;
  ramm._pi := 1;
  tSRaam(ramm);
  Beeep;
  rk;
  TPopImage(ramm._pi);
end;


procedure TPopImage(var p_image : byte);
var
  p1, p2 : ^B8192;
  a_image : byte;
  pi1 : integer;
  f : file;
  NumRead,vidmem : word;
  s : string;
begin
  a_image := p_image;
  if a_image>20 then dec(a_image,20);
  if lastmode=7 then vidmem := $B000 else vidmem := $B800;

  with tImage[a_image] do if bezet>0 then
   begin
    p1 := Ptr(vidmem, 0);

    if bezet=2 then
     begin
      str(a_image,s);
      assign(f, TempDir + '\IMAGE' + s);
      reset(f,8192);
      BlockRead(f,p1^,1,NumRead);
      close(f);

      if p_image < 21 then
       begin
        erase(f);
        bezet := 0;
       end;
     end
    else
     begin
      p2 := buffer;
      move(p2^, p1^, 8000);

      if p_image < 21 then
       begin
        freemem(Buffer,8192);
        bezet := 0;
       end;
     end;
   end
end;


procedure TPushImage(var p_image : byte);
var
  a_image : byte;
  pi1 : integer;
  p1, p2 : ^B8192;
  s : string;
  f : file;
  NumWritten,vidmem,w1,w2 : word;
begin
  if p_image=0 then exit;

  a_image := 1;
  while ((timage[a_image].bezet<>0) and (a_image<21)) do inc(a_image);
  if a_image=21 then exit;
    if lastmode=7 then vidmem := $B000 else vidmem := $B800;

  with TImage[a_image] do
   begin
    p1 := Ptr(vidmem, 0);
    bezet := 1;

    if ((memavail < 9000) or (p_image in [98, 99])) then
     begin
      bezet := 2;
      str(a_image,s);
      assign(f, TempDir + '\IMAGE' + s);
      rewrite(f, 8192);
      BlockWrite(f,p1^,1,NumWritten);
      close(f);
      if (p_image = 99) then inc(a_image, 20);
     end
    else
     begin
      getmem(buffer,8192);
      w1 := memw[seg(buffer):ofs(buffer)+2];
      w2 := memw[seg(buffer):ofs(buffer)];
      p2 := buffer;
      move(p1^, p2^, 8000);
     end;
   end;
  p_image := a_image;
end;


procedure TRaam(var tg:t_graph);
var
  lb,rb,lo,ro,lt,rt,ht,ho,ve,tl,rso:byte;
  x,y : integer;
  regs:registers;
begin
  with tg do
   begin
    window(1,1,maxx,maxy);
    rso := _so mod 4;
    if _so in [4..7,12..15] then
     begin
      lb := 218;
      rb := 191;
      lo := 192;
      ro := 217;
      lt := 195;
      rt := 180;
      ht := 196;
      ho := 196;
      ve := 179;
     end
      else
     begin
      lb := 201;
      rb := 187;
      lo := 200;
      ro := 188;
      lt := 199;
      rt := 182;
      ht := 196;
      ho := 205;
      ve := 186;
     end;

    textbackground(klPanBordBck);
    textcolor(klPanBorder);

    if rso in [2,3] then
     begin
      _x1 := _x1-((_x2+2) div 2)+1;
      _y1 := _y1-((_y2+4) div 2);

      if rso=3 then inc(_y1);

      _x2 := _x1+_x2+1;
      _y2 := _y1+_y2+3;

      if rso=3 then dec(_y2,2);
     end;

    tpushimage(tg._pi);
    place(_x1,_y1,lb);
    place(_x2,_y1,rb);

    for y := _y1+1 to _y2-1 do
     begin
      place(_x1,y,ve);
      place(_x2,y,ve);
     end;

    for x := _x1+1 to _x2-1 do
     begin
      place(x,_y1,ho);
      place(x,_y2,ho);
      if rso in [0,2] then place(x,_y1+2,ht);
     end;

    if rso in [0,2] then place(_x1,_y1+2,lt);
    if rso in [0,2] then place(_x2,_y1+2,rt);
    place(_x1,_y2,lo);

    if ((_x2<>maxx) or (_y2<>maxy)) then place(_x2,_y2,ro) else
     with regs do
      begin
       gotoxy(_x2-1,_y2);
       AH := 8;
       BH := 0;
       intr($10,regs);
       gotoxy(_x2,_y2);
       BL := AH;
       AH := 9;
       AL := ro;
       CX := 1;
       intr($10,regs);
      end;

    if rso in [0,2] then textbackground(klPanHeadBck) else textbackground(klPanBckgnd);
    for x := _x1+1 to _x2-1 do place(x,_y1+1,32);

    for x := 1 to length(_kt) do place((_x2+_x1) div 2-(length(_kt) div 2)+x
      ,_y1+1,ord(_kt[x]));

    if ((_so in [8..15]) and (lastmode<>7)) then
     begin
      textbackground(white);
      textcolor(darkgray);
      gotoxy(_x1+1,_y2+1);
      for x := 0 to _x2-_x1 do write(chr(223));
      gotoxy(_x2+1,_y1);
      write(chr(220));
      gotoxy(_x2+1,_y2+1);
      write(chr(223));
      for x := 0 to _y2-_y1-1 do place(_x2+1,_y1+1+x,219);
     end;

    textbackground(klPanBckgnd); textcolor(klPanTxt);
    if rso in [0,2] then tl := 3 else tl := 2;
    for x := _x1+1 to _x2-1 do for y := _y1+tl to _y2-1 do
     place(x,y,32);
    window(1,1,maxx,maxy);
   end;
end;


procedure TShowBaseline(pst:string);
begin
  window(1,1,maxx,maxy);
  textColor(klMessage);
  textbackground(klMessageBck);
  gotoxy(2,maxy);
  write(Blank(78));
  gotoxy((MaxX div 2) - (length(pst) div 2), maxy);
  write(pst);
end;


procedure TShowMenu(var sm:t_menu;pgr:t_graph);
var
  m_ok : boolean;
  b : byte;
  v, toets : char;
  l,y,t,xc,yc,ry : integer;
  gwr : t_graph;

 procedure p_gwr(i1:integer);
 begin
  gwr._x1 := pgr._x1+2;
  gwr._y1 := ry+y;
  gwr._oc := sm._li[y+1];
  gwr._kt := sm._me[y];
  gwr._so := i1;
  tgwrite(gwr);
 end;

begin
with sm do with pgr do
 begin
  CursorOff;

  if _mk>_ar then _mk := _ar;
  if MouseActive then MouseOff;
  l := length(_kt);
  for t := 0 to _ar do if length(_me[t])>l then l := length(_me[t]);
  for t := 0 to _ar do _me[t] := ml(_me[t],l,true);

  _y2 := _ar+1;
  _x2 := l+2;

  b := _so and $FC;
  if (length(_kt) = 0) then _so := b+3
   else _so := b +2;
  traam(pgr);

  if (length(_kt) = 0) then ry := _y1+1 else ry := _y1+3;
  with gwr do for t := 0 to _ar do
   begin
    _x1 := pgr._x1+2;
    _y1 := ry+t;
    _oc := _li[t+1];
    _kt := _me[t];
    _so := 0;
    tgwrite(gwr);
   end;

  y := _mk;
  with gwr do
   begin
    _y1 := ry+y;
    _oc := _li[_mk+1];
    _kt := _me[_mk];
    _so := 1;
    tgwrite(gwr);
   end;
  _mk := 0;

  if MouseActive then
   begin
    MouseOn;
    if _mg then MouseWindow(_x1, _y1, _x2, _y2);
   end;

  repeat
   Buttons := 0;
   m_ok := false;

   repeat
{
    callvector(new_vec);
    if (_mu and MouseActive) then muis_in_t(true);
}
   until (keypressed or (Buttons>0));

   if Buttons>0 then
    begin
     for t := 0 to _ar do
       if ((MouseX>=_x1+1) and (MouseX<_x1+1+l) and (MouseY=ry+t)) then
      begin
       m_ok := true;
       _mk := t;
      end;
    end
     else
    begin
     v := ReadKey;
     if v<>#0 then for t := 0 to _ar do
      if UpCase(_li[t+1])=UpCase(v) then
       begin
        v := #13;
        _mk := t;
       end;
     if v=#0 then
      begin
       repeat until KeyPressed;
       Toets := ReadKey;
       case toets of
        #72 : if y>0 then
         begin
          if MouseActive then MouseOff;
          p_gwr(0);
          y := y-1;
          p_gwr(1);
          if MouseActive then MouseOn;
         end;
        #80 : if y<_ar then
         begin
          if MouseActive then MouseOff;
          p_gwr(0);
          y := y+1;
          p_gwr(1);
          if MouseActive then MouseOn;
         end;
       end;
       _mk := y;
      end;
    end;
  until ((v in [#10,#13,#27]) or m_ok);
  if v=#27 then _mk := 99;
  if _pi>0 then
   begin
    if MouseActive then MouseOff;
    tpopimage(pgr._pi);
   end;
  if MouseActive then
   begin
    MouseOn;
    MouseWindow(0, 0, maxx, maxy);
   end;

  CursorOn;
 end;
end;


procedure TSRaam(var ramm : t_graph);
var tram : t_graph;
begin
  tram := ramm;
  with tram do
   begin
    _kt := '  '+_kt+'  ';
    _x1 := Maxx div 2;
    _y1 := Maxy div 2;
    _x2 := (length(_kt)+2);
    _y2 := 1;
    if not(_so in [3,7]) then _so := 3;
   end;
  traam(tram);
end;


procedure Wait; assembler;
{-----------------------------------------------------------------------------
Wait n cycles of 8253/8254 timer
Input : AX: number of cycles to wait
-----------------------------------------------------------------------------}
asm
    push ax;
    mov al, $B0;
    out $43, al;
    pop ax;
    out $42, al;
    mov al, ah;
    out $42, al;
    in al, $61;
    and al, $FD;
    or al, 1;
    out $61, al;
@2: in al, $61;
    and al, $20;
    je @2;
end;


procedure WaitKey;
var c : char;
begin
  while KeyPressed do c := ReadKey;
end;


begin
  for klQueTxt := 1 to 10 do tImage[klQueTxt].bezet := 0;

  TempDir := GetEnv('TEMP');
  if TempDir = '' then TempDir := GetEnv('TMP');

  if TempDir = '' then
   begin
    {$I-} mkdir('C:\TEMP'); {$I+}
    if (IOresult = 0) then TempDir := 'C:\TEMP'
     else TempDir := '.';
   end;
end.


